# Uses of Class
org.apache.lucene.store.IndexOutput

Packages that use IndexOutput
Package
Description
org.apache.lucene.codecs
Codecs API: API for customization of the encoding and structure of the index.
org.apache.lucene.codecs.lucene103
Lucene 10.3 file format.
org.apache.lucene.codecs.lucene90
Lucene 9.0 file format.
org.apache.lucene.codecs.lucene95
Lucene 9.5 file format.
org.apache.lucene.codecs.lucene99
Lucene 9.9 file format.
org.apache.lucene.index
Code to maintain and access indices.
org.apache.lucene.store
Binary i/o API, used for all index data.
org.apache.lucene.util
Some utility classes.
org.apache.lucene.util.bkd
Block KD-tree, implementing the generic spatial data structure described in this paper.
org.apache.lucene.util.packed
Packed integer arrays and streams.

- ## Uses of IndexOutput in org.apache.lucene.codecs

  Methods in org.apache.lucene.codecs that return IndexOutput
  Modifier and Type
  Method
  Description
  `final IndexOutput`
  CompoundDirectory.`createOutput(String name, IOContext context)`
  `final IndexOutput`
  CompoundDirectory.`createTempOutput(String prefix, String suffix, IOContext context)`
  Methods in org.apache.lucene.codecs with parameters of type IndexOutput
  Modifier and Type
  Method
  Description
  `abstract void`
  PostingsWriterBase.`init(IndexOutput termsOut, SegmentWriteState state)`
  Called once after startup, before any terms have been added.
  `static void`
  CodecUtil.`writeFooter(IndexOutput out)`
  Writes a codec footer, which records both a checksum algorithm ID and a checksum.
  `protected void`
  MultiLevelSkipListWriter.`writeLevelLength(long levelLength, IndexOutput output)`
  Writes the length of a level to the given output.
  `long`
  MultiLevelSkipListWriter.`writeSkip(IndexOutput output)`
  Writes the buffered skip lists to the given output.

- ## Uses of IndexOutput in org.apache.lucene.codecs.lucene103

  Methods in org.apache.lucene.codecs.lucene103 with parameters of type IndexOutput
  Modifier and Type
  Method
  Description
  `void`
  Lucene103PostingsWriter.`init(IndexOutput termsOut, SegmentWriteState state)`

- ## Uses of IndexOutput in org.apache.lucene.codecs.lucene90

  Fields in org.apache.lucene.codecs.lucene90 declared as IndexOutput
  Modifier and Type
  Field
  Description
  `protected final IndexOutput`
  Lucene90PointsWriter.`dataOut`
  Outputs used to write the BKD tree data files.
  `protected final IndexOutput`
  Lucene90PointsWriter.`indexOut`
  Outputs used to write the BKD tree data files.
  `protected final IndexOutput`
  Lucene90PointsWriter.`metaOut`
  Outputs used to write the BKD tree data files.
  Methods in org.apache.lucene.codecs.lucene90 with parameters of type IndexOutput
  Modifier and Type
  Method
  Description
  `static short`
  IndexedDISI.`writeBitSet(DocIdSetIterator it, IndexOutput out, byte denseRankPower)`
  Writes the docIDs from it to out, in logical blocks, one for each 65536 docIDs in monotonically increasing gap-less order.

- ## Uses of IndexOutput in org.apache.lucene.codecs.lucene95

  Methods in org.apache.lucene.codecs.lucene95 with parameters of type IndexOutput
  Modifier and Type
  Method
  Description
  `static void`
  OrdToDocDISIReaderConfiguration.`writeStoredMeta(int directMonotonicBlockShift, IndexOutput outputMeta, IndexOutput vectorData, int count, int maxDoc, DocsWithFieldSet docsWithField)`
  Writes out the docsWithField and ordToDoc mapping to the outputMeta and vectorData respectively.

- ## Uses of IndexOutput in org.apache.lucene.codecs.lucene99

  Methods in org.apache.lucene.codecs.lucene99 with parameters of type IndexOutput
  Modifier and Type
  Method
  Description
  `static DocsWithFieldSet`
  Lucene99ScalarQuantizedVectorsWriter.`writeQuantizedVectorData(IndexOutput output, QuantizedByteVectorValues quantizedByteVectorValues, byte bits, boolean compress)`
  Writes the vector values to the output and returns a set of documents that contains vectors.

- ## Uses of IndexOutput in org.apache.lucene.index

  Methods in org.apache.lucene.index with parameters of type IndexOutput
  Modifier and Type
  Method
  Description
  `void`
  SegmentInfos.`write(IndexOutput out)`
  Write ourselves to the provided `IndexOutput`

- ## Uses of IndexOutput in org.apache.lucene.store

  Subclasses of IndexOutput in org.apache.lucene.store
  Modifier and Type
  Class
  Description
  `final class`
  `ByteBuffersIndexOutput`
  An `IndexOutput` writing to a `ByteBuffersDataOutput`.
  `class`
  `FilterIndexOutput`
  IndexOutput implementation that delegates calls to another directory.
  `class`
  `OutputStreamIndexOutput`
  Implementation class for buffered `IndexOutput` that writes to an `OutputStream`.
  `final class`
  `RateLimitedIndexOutput`
  A `rate limiting` `IndexOutput`
  Fields in org.apache.lucene.store declared as IndexOutput
  Modifier and Type
  Field
  Description
  `protected final IndexOutput`
  FilterIndexOutput.`out`
  Methods in org.apache.lucene.store that return IndexOutput
  Modifier and Type
  Method
  Description
  `IndexOutput`
  ByteBuffersDirectory.`createOutput(String name, IOContext context)`
  `abstract IndexOutput`
  Directory.`createOutput(String name, IOContext context)`
  Creates a new, empty file in the directory and returns an `IndexOutput` instance for appending data to this file.
  `IndexOutput`
  FileSwitchDirectory.`createOutput(String name, IOContext context)`
  `IndexOutput`
  FilterDirectory.`createOutput(String name, IOContext context)`
  `IndexOutput`
  FSDirectory.`createOutput(String name, IOContext context)`
  `IndexOutput`
  LockValidatingDirectoryWrapper.`createOutput(String name, IOContext context)`
  `IndexOutput`
  NRTCachingDirectory.`createOutput(String name, IOContext context)`
  `IndexOutput`
  TrackingDirectoryWrapper.`createOutput(String name, IOContext context)`
  `IndexOutput`
  ByteBuffersDirectory.`createTempOutput(String prefix, String suffix, IOContext context)`
  `abstract IndexOutput`
  Directory.`createTempOutput(String prefix, String suffix, IOContext context)`
  Creates a new, empty, temporary file in the directory and returns an `IndexOutput` instance for appending data to this file.
  `IndexOutput`
  FileSwitchDirectory.`createTempOutput(String prefix, String suffix, IOContext context)`
  `IndexOutput`
  FilterDirectory.`createTempOutput(String prefix, String suffix, IOContext context)`
  `IndexOutput`
  FSDirectory.`createTempOutput(String prefix, String suffix, IOContext context)`
  `IndexOutput`
  NRTCachingDirectory.`createTempOutput(String prefix, String suffix, IOContext context)`
  `IndexOutput`
  TrackingDirectoryWrapper.`createTempOutput(String prefix, String suffix, IOContext context)`
  `final IndexOutput`
  FilterIndexOutput.`getDelegate()`
  Gets the delegate that was passed in on creation
  `static IndexOutput`
  FilterIndexOutput.`unwrap(IndexOutput out)`
  Unwraps all FilterIndexOutputs until the first non-FilterIndexOutput IndexOutput instance and returns it
  Methods in org.apache.lucene.store with parameters of type IndexOutput
  Modifier and Type
  Method
  Description
  `static IndexOutput`
  FilterIndexOutput.`unwrap(IndexOutput out)`
  Unwraps all FilterIndexOutputs until the first non-FilterIndexOutput IndexOutput instance and returns it
  Constructors in org.apache.lucene.store with parameters of type IndexOutput
  Modifier
  Constructor
  Description
  `protected`
  `FilterIndexOutput(String resourceDescription, String name, IndexOutput out)`
  Creates a FilterIndexOutput with a resource description, name, and wrapped delegate IndexOutput
  ``
  `RateLimitedIndexOutput(RateLimiter rateLimiter, IndexOutput out)`

- ## Uses of IndexOutput in org.apache.lucene.util

  Fields in org.apache.lucene.util declared as IndexOutput
  Modifier and Type
  Field
  Description
  `protected final IndexOutput`
  OfflineSorter.ByteSequencesWriter.`out`
  Methods in org.apache.lucene.util with parameters of type IndexOutput
  Modifier and Type
  Method
  Description
  `protected OfflineSorter.ByteSequencesWriter`
  OfflineSorter.`getWriter(IndexOutput out, long itemCount)`
  Subclasses can override to change how byte sequences are written to disk.
  Constructors in org.apache.lucene.util with parameters of type IndexOutput
  Modifier
  Constructor
  Description
  ``
  `ByteSequencesWriter(IndexOutput out)`
  Constructs a ByteSequencesWriter to the provided DataOutput

- ## Uses of IndexOutput in org.apache.lucene.util.bkd

  Fields in org.apache.lucene.util.bkd declared as IndexOutput
  Modifier and Type
  Field
  Description
  `final IndexOutput`
  OfflinePointWriter.`out`
  Methods in org.apache.lucene.util.bkd with parameters of type IndexOutput
  Modifier and Type
  Method
  Description
  `IORunnable`
  BKDWriter.`finish(IndexOutput metaOut, IndexOutput indexOut, IndexOutput dataOut)`
  Writes the BKD tree to the provided `IndexOutput`s and returns a `Runnable` that writes the index of the tree if at least one point has been added, or `null` otherwise.
  `IORunnable`
  BKDWriter.`merge(IndexOutput metaOut, IndexOutput indexOut, IndexOutput dataOut, List<MergeState.DocMap> docMaps, List<PointValues> readers)`
  More efficient bulk-add for incoming `PointValues`s.
  `IORunnable`
  BKDWriter.`writeField(IndexOutput metaOut, IndexOutput indexOut, IndexOutput dataOut, String fieldName, MutablePointTree reader)`
  Write a field from a `MutablePointTree`.

- ## Uses of IndexOutput in org.apache.lucene.util.packed

  Methods in org.apache.lucene.util.packed with parameters of type IndexOutput
  Modifier and Type
  Method
  Description
  `static DirectMonotonicWriter`
  DirectMonotonicWriter.`getInstance(IndexOutput metaOut, IndexOutput dataOut, long numValues, int blockShift)`
  Returns an instance suitable for encoding `numValues` into monotonic blocks of 2`blockShift` values.